// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcItemMapFieldNames          = builder.RawFieldNames(&DcItemMap{})
	dcItemMapRows                = strings.Join(dcItemMapFieldNames, ",")
	dcItemMapRowsExpectAutoSet   = strings.Join(stringx.Remove(dcItemMapFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcItemMapRowsWithPlaceHolder = strings.Join(stringx.Remove(dcItemMapFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcItemMapModel interface {
		Insert(ctx context.Context, data *DcItemMap) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcItemMap, error)
		FindOneByProjectIdSourceItem(ctx context.Context, projectId int64, sourceItem string) (*DcItemMap, error)
		Update(ctx context.Context, data *DcItemMap) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcItemMapModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcItemMap struct {
		Id         int64  `db:"id"`
		ProjectId  int64  `db:"project_id"`  // 项目 ID
		DeviceCode string `db:"device_code"` // 设备位号
		SourceItem string `db:"source_item"` // 来源 item 名
		TargetItem string `db:"target_item"` // 目标item 名，也就是数据中心的 item 名
		Alias      string `db:"alias"`       // 点位名描述
	}
)

func newDcItemMapModel(conn sqlx.SqlConn) *defaultDcItemMapModel {
	return &defaultDcItemMapModel{
		conn:  conn,
		table: "`dc_item_map`",
	}
}

func (m *defaultDcItemMapModel) withSession(session sqlx.Session) *defaultDcItemMapModel {
	return &defaultDcItemMapModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_item_map`",
	}
}

func (m *defaultDcItemMapModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcItemMapModel) FindOne(ctx context.Context, id int64) (*DcItemMap, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcItemMapRows, m.table)
	var resp DcItemMap
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcItemMapModel) FindOneByProjectIdSourceItem(ctx context.Context, projectId int64, sourceItem string) (*DcItemMap, error) {
	var resp DcItemMap
	query := fmt.Sprintf("select %s from %s where `project_id` = ? and `source_item` = ? limit 1", dcItemMapRows, m.table)
	err := m.conn.QueryRowCtx(ctx, &resp, query, projectId, sourceItem)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcItemMapModel) Insert(ctx context.Context, data *DcItemMap) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, dcItemMapRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.SourceItem, data.TargetItem, data.Alias)
	return ret, err
}

func (m *defaultDcItemMapModel) Update(ctx context.Context, newData *DcItemMap) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcItemMapRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, newData.ProjectId, newData.DeviceCode, newData.SourceItem, newData.TargetItem, newData.Alias, newData.Id)
	return err
}

func (m *defaultDcItemMapModel) tableName() string {
	return m.table
}
