// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcWorkingPumpFieldNames          = builder.RawFieldNames(&DcWorkingPump{})
	dcWorkingPumpRows                = strings.Join(dcWorkingPumpFieldNames, ",")
	dcWorkingPumpRowsExpectAutoSet   = strings.Join(stringx.Remove(dcWorkingPumpFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcWorkingPumpRowsWithPlaceHolder = strings.Join(stringx.Remove(dcWorkingPumpFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcWorkingPumpModel interface {
		MultiInsert(ctx context.Context, datas []DcWorkingPump) (int64, error)
		Insert(ctx context.Context, data *DcWorkingPump) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcWorkingPump, error)
		Update(ctx context.Context, data *DcWorkingPump) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcWorkingPumpModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcWorkingPump struct {
		Id           int64     `db:"id"`
		ProjectId    int64     `db:"project_id"`
		DeviceCode   string    `db:"device_code"`
		FeedPressure float64   `db:"feed_pressure"` // 进水压力
		OutPressure  float64   `db:"out_pressure"`  // 出水压力
		Duration     int64     `db:"duration"`      // 运行时长 单位 s
		Current      float64   `db:"current"`       // 运行电流
		Frequency    float64   `db:"frequency"`     // 运行频率
		Lift         float64   `db:"lift"`          // 工作扬程
		Efficiency   float64   `db:"efficiency"`    // 运行效率
		RunStatus    int64     `db:"run_status"`    // 运行状态 0： 停机 1： 运行正常
		FaultStatus  int64     `db:"fault_status"`  // 故障状态 0： 正常 1： 故障
		CTime        time.Time `db:"c_time"`
	}
)

func newDcWorkingPumpModel(conn sqlx.SqlConn) *defaultDcWorkingPumpModel {
	return &defaultDcWorkingPumpModel{
		conn:  conn,
		table: "`dc_working_pump`",
	}
}

func (m *defaultDcWorkingPumpModel) withSession(session sqlx.Session) *defaultDcWorkingPumpModel {
	return &defaultDcWorkingPumpModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_working_pump`",
	}
}

func (m *defaultDcWorkingPumpModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcWorkingPumpModel) FindOne(ctx context.Context, id int64) (*DcWorkingPump, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcWorkingPumpRows, m.table)
	var resp DcWorkingPump
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcWorkingPumpModel) MultiInsert(ctx context.Context, datas []DcWorkingPump) (int64, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingPumpRowsExpectAutoSet)

	if bulk, err := sqlx.NewBulkInserter(m.conn, query);err == nil {
		for _, data := range datas {
			if err = bulk.Insert(data.ProjectId, data.DeviceCode, data.FeedPressure, data.OutPressure, data.Duration, data.Current, data.Frequency, data.Lift, data.Efficiency, data.RunStatus, data.FaultStatus, data.CTime);err != nil {
				return 0, err
			}
		}

		bulk.Flush()
		return int64(len(datas)), nil
	} else {
		return 0, err
	}
}

func (m *defaultDcWorkingPumpModel) Insert(ctx context.Context, data *DcWorkingPump) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcWorkingPumpRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.FeedPressure, data.OutPressure, data.Duration, data.Current, data.Frequency, data.Lift, data.Efficiency, data.RunStatus, data.FaultStatus, data.CTime)
	return ret, err
}

func (m *defaultDcWorkingPumpModel) Update(ctx context.Context, data *DcWorkingPump) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcWorkingPumpRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.FeedPressure, data.OutPressure, data.Duration, data.Current, data.Frequency, data.Lift, data.Efficiency, data.RunStatus, data.FaultStatus, data.CTime, data.Id)
	return err
}

func (m *defaultDcWorkingPumpModel) tableName() string {
	return m.table
}
